#include <stdio.h>
#include <stdlib.h>
#include <stdatomic.h>
#include "basic-c11.h"



static int n = 1000 ;
static volatile int sum = 0 ;
static atomic_int start = ATOMIC_VAR_INIT(0) ;
static mtx_t *mtx;

int f(void *p) {
  while (!atomic_load_explicit(&start,memory_order_acquire)) ;
  // Atomic increment of sum
  lock_mutex(mtx) ;
  sum++ ;
  unlock_mutex(mtx) ;
  return 0 ;
}

void run_loose(void) {
  int broken = 0 ;
  mtx = alloc_mutex() ;
  for (int k = n ; k > 0 ; k--) {
    sum = 0 ;
    atomic_store_explicit(&start,0,memory_order_release) ;
    thrd_t th1,th2 ;
    create_thread(&th1,f,NULL) ;
    create_thread(&th2,f,NULL) ;
    atomic_store_explicit(&start,1,memory_order_relaxed) ;
    (void)join_thread(th2) ;
    (void)join_thread(th1) ;
    if (atomic_load_explicit(&sum,memory_order_relaxed) != 2) broken++ ;
  }
  free_mutex(mtx) ;
  printf("Broken:  %i/%i\n",broken,n) ;
}

int main (int argc, char **argv) {
  if (argc > 1) n = atoi(argv[1]) ;
  run_loose() ;
  return 0 ;
}
