#include <stdio.h>
#include <stdlib.h>
#include <stdatomic.h>
#include "basic-c11.h"



static int n = 10000 ;
atomic_int sum = ATOMIC_VAR_INIT(0) ;
atomic_int start = ATOMIC_VAR_INIT(0) ;

int f(void *p) {
  while (!atomic_load_explicit(&start,memory_order_relaxed)) ;
  // Atomic increment of sum
  (void)atomic_fetch_add_explicit(&sum,1,memory_order_relaxed) ;
  return 0 ;
}

void run_loose(void) {
  int broken = 0 ;
  for (int k = n ; k > 0 ; k--) {
    atomic_store_explicit(&sum,0,memory_order_relaxed) ;
    atomic_store_explicit(&start,0,memory_order_relaxed) ;
    thrd_t th1,th2 ;
    create_thread(&th1,f,NULL) ;
    create_thread(&th2,f,NULL) ;
    atomic_store_explicit(&start,1,memory_order_relaxed) ;
    (void)join_thread(th2) ;
    (void)join_thread(th1) ;
    if (atomic_load_explicit(&sum,memory_order_relaxed) != 2) broken++ ;
  }
  printf("Broken:  %i/%i\n",broken,n) ;
}

int main (int argc, char **argv) {
  if (argc > 1) n = atoi(argv[1]) ;
  run_loose() ;
  return 0 ;
}
